; ###################################################################################################
; #                                    JV-ODE - 2D Spheres Demo                                     #
; #                                  Code by Jim Williams (VIP3R)                                   #
; #                              Devious Codeworks - Copyright  2008                               #
; ###################################################################################################

Include "JV-ODE.bb"

AppTitle "JV-ODE - 2D Spheres Demo"

Graphics 800,600,0,2

Type ODEGeom
	Field body
	Field geom
	Field r
	Field g
	Field b
End Type

; ###################################################################################################

; ### Setup ODE

dInitODE()

Global World=dWorldCreate()
Global Space=dHashSpaceCreate(0)
Global ContactGroup=dJointGroupCreate(0)

dWorldSetAutoDisableFlag(World,1)
dWorldSetGravity(World,0,-9.8,0)
dContactSetMode(dContactBounce)
dContactSetBounce(0.8)
dContactSetMu(48)

; ### Create Plane

dCreatePlane(Space,0,1,0,0)

; ###################################################################################################

SetBuffer BackBuffer()

While Not KeyHit(1)

	Cls

	If MilliSecs()-Timer>800
		AddObject()
		Timer=MilliSecs()
		End If

	UpdateGeoms()

	PTime=MilliSecs()

	dSpaceCollide(Space,World,ContactGroup)
	dWorldQuickStep(World,0.05)
	dJointGroupEmpty(ContactGroup)

	PhysicsTime#=MilliSecs()-PTime

	Text 0,0,"JV-ODE Version "+dGetVersion()
	Text 0,15,"Physics Time:"+PhysicsTime

	Flip 1

Wend

dJointGroupDestroy(ContactGroup)
dSpaceDestroy(Space)
dWorldDestroy(World)
dCloseODE()

End

; ###################################################################################################

Function AddObject()

xp#=Rand(-80,80)

ode.ODEGeom=New ODEGeom
ode\body=dBodyCreate(World)
dBodySetPosition(ode\body,xp,500,0)
dBodySetRotation(ode\body,0,0,0)
dBodySetAutoDisableFlag(ode\body,1)
ode\geom=dCreateSphere(Space,14)
dGeomSetBody(ode\geom,ode\body)
ode\r=Rand(0,255)
ode\g=Rand(0,255)
ode\b=Rand(0,255)

Joint2D=dJointCreatePlane2D(World,0)
dJointAttach(Joint2D,ode\body,0)

End Function

; ###################################################################################################

Function UpdateGeoms()

For ode.ODEGeom=Each ODEGeom
	If ode\body
		Color ode\r,ode\g,ode\b
		xpos#=400+dGeomGetPositionX(ode\geom)
		ypos#=580-dGeomGetPositionY(ode\geom)
		Oval xpos,ypos,28,28

		Color 255,255,255
		angle#=-dGeomGetRoll(ode\geom)
		px#=Cos(angle)*10+xpos
		py#=Sin(angle)*10+ypos
		Oval 10+px,10+py,8,8
		End If
Next

End Function

; ###################################################################################################
