; ###################################################################################################
; #                                     JV-ODE Physics Wrapper                                      #
; #                                  Code by Jim Williams (VIP3R)                                   #
; #                              Devious Codeworks - Copyright  2008                               #
; #                                                                                                 #
; #              NOTE: PLEASE DO NOT POST OR PUBLISH ANY PART OF THIS INCLUDE FILE!!!               #
; ###################################################################################################

; ##########################################################
; # PLEASE KEEP YOUR JV-ODE REGISTRATION KEY CONFIDENTIAL! #
; ##########################################################
dRegisterODE($448E3714,$302CD447,$C40D784F,$7D3CE032)     ;#
; ##########################################################

; ### Maximum Supported User Classes
Const dMaxUserClasses=4

; ### Geometry Classes
Const dSphereClass=0
Const dBoxClass=1
Const dCapsuleClass=2
Const dCylinderClass=3
Const dPlaneClass=4
Const dRayClass=5
Const dGeomTransformClass=6
Const dTriMeshClass=7
Const dFirstSpaceClass=8
Const dSimpleSpaceClass=dFirstSpaceClass
Const dHashSpaceClass=9
Const dQuadTreeSpaceClass=10
Const dLastSpaceClass=dQuadTreeSpaceClass
Const dFirstUserClass=11
Const dLastUserClass=dFirstUserClass+dMaxUserClasses-1
Const dGeomNumClasses=dFirstUserClass+dMaxUserClasses

; ### Joint Types
Const dJointTypeNone=0
Const dJointTypeBall=1
Const dJointTypeHinge=2
Const dJointTypeSlider=3
Const dJointTypeContact=4
Const dJointTypeUniversal=5
Const dJointTypeHinge2=6
Const dJointTypeFixed=7
Const dJointTypeNull=8
Const dJointTypeAMotor=9
Const dJointTypeLMotor=10
Const dJointTypePlane2D=11
Const dJointTypePR=12
Const dJointTypePU=13
Const dJointTypePiston=14

; ### Motor Modes
Const dAMotorUser=0
Const dAMotorEuler=1

; ### Joint Parameters
Const dParamLoStop=0
Const dParamHiStop=1
Const dParamVel=2
Const dParamFMax=3
Const dParamFudgeFactor=4
Const dParamBounce=5
Const dParamCFM=6
Const dParamStopERP=7
Const dParamStopCFM=8
Const dParamSuspensionERP=9
Const dParamSuspensionCFM=10
Const dParamLoStop2=$100+0
Const dParamHiStop2=$100+1
Const dParamVel2=$100+2
Const dParamFMax2=$100+3
Const dParamFudgeFactor2=$100+4
Const dParamBounce2=$100+5
Const dParamCFM2=$100+6
Const dParamStopERP2=$100+7
Const dParamStopCFM2=$100+8
Const dParamSuspensionERP2=$100+9
Const dParamSuspensionCFM2=$100+10
Const dParamLoStop3=$200+0
Const dParamHiStop3=$200+1
Const dParamVel3=$200+2
Const dParamFMax3=$200+3
Const dParamFudgeFactor3=$200+4
Const dParamBounce3=$200+5
Const dParamCFM3=$200+6
Const dParamStopERP3=$200+7
Const dParamStopCFM3=$200+8
Const dParamSuspensionERP3=$200+9
Const dParamSuspensionCFM3=$200+10

; ### Contact Modes
Const dContactMu2=$001
Const dContactFDir1=$002
Const dContactBounce=$004
Const dContactSoftERP=$008
Const dContactSoftCFM=$010
Const dContactMotion1=$020
Const dContactMotion2=$040
Const dContactMotionN=$080
Const dContactSlip1=$100
Const dContactSlip2=$200
Const dContactApprox0=$0000
Const dContactApprox1_1=$1000
Const dContactApprox1_2=$2000
Const dContactApprox1=$3000

; ### Misc
Const dInfinity#=340282357000000000000000000000000000000.0

; ###################################################################################################

Function CreateTriMesh(trispace,mesh)

TriCount=0
VertCount=0

For Count=1 To CountSurfaces(mesh)
	TriCount=TriCount+CountTriangles(GetSurface(mesh,Count))
	VertCount=VertCount+CountVertices(GetSurface(mesh,Count))
Next

TriBank=CreateBank(TriCount*3*4)
VertBank=CreateBank(VertCount*3*4)

Offset=0
TriOffset=0
VertOffset=0

For Count=1 To CountSurfaces(mesh)
	Surface=GetSurface(mesh,Count)
	For Vert=0 To CountVertices(Surface)-1
		PokeFloat(VertBank,Offset,VertexX(Surface,Vert))
		Offset=Offset+4
		PokeFloat(VertBank,Offset,VertexY(Surface,Vert))
		Offset=Offset+4
		PokeFloat(VertBank,Offset,VertexZ(Surface,Vert))
		Offset=Offset+4
	Next
	For Tri=0 To CountTriangles(Surface)-1
		For Corner=0 To 2
			PokeInt(TriBank,TriOffset,TriangleVertex(Surface,Tri,Corner)+VertOffset)
			TriOffset=TriOffset+4
		Next
	Next
	VertOffset=VertOffset+CountVertices(Surface)
Next

TriMeshData=dGeomTriMeshDataCreate()

dGeomTriMeshDataBuildSingle(TriMeshData,VertBank,4,VertCount,TriBank,TriCount*3,4)

Return dCreateTriMesh(trispace,TriMeshData)

End Function

; ###################################################################################################

Function CreateAnimTriMesh(trispace,mesh,layer)

TriCount=0
VertCount=0

For Count=1 To CountSurfaces(GetChild(mesh,layer))
	TriCount=TriCount+CountTriangles(GetSurface(GetChild(mesh,layer),Count))
	VertCount=VertCount+CountVertices(GetSurface(GetChild(mesh,layer),Count))
Next

TriBank=CreateBank(TriCount*3*4)
VertBank=CreateBank(VertCount*3*4)

Offset=0
TriOffset=0
VertOffset=0

For Count=1 To CountSurfaces(GetChild(mesh,layer))
	Surface=GetSurface(GetChild(mesh,layer),Count)
	For Vert=0 To CountVertices(Surface)-1
		PokeFloat(VertBank,Offset,VertexX(Surface,Vert))
		Offset=Offset+4
		PokeFloat(VertBank,Offset,VertexY(Surface,Vert))
		Offset=Offset+4
		PokeFloat(VertBank,Offset,VertexZ(Surface,Vert))
		Offset=Offset+4
	Next
	For Tri=0 To CountTriangles(Surface)-1
		For Corner=0 To 2
			PokeInt(TriBank,TriOffset,TriangleVertex(Surface,Tri,Corner)+VertOffset)
			TriOffset=TriOffset+4
		Next
	Next
	VertOffset=VertOffset+CountVertices(Surface)
Next

TriMeshData=dGeomTriMeshDataCreate()

dGeomTriMeshDataBuildSingle(TriMeshData,VertBank,4,VertCount,TriBank,TriCount*3,4)

Return dCreateTriMesh(trispace,TriMeshData)

End Function

; ###################################################################################################

Function PlaneTexture()

PlaneTexture=CreateTexture(128,128,9)

SetBuffer TextureBuffer(PlaneTexture)

Color 0,200,80
Rect 0,0,128,128

Color 255,255,255
Rect 0,0,64,64
Rect 64,64,64,64

ScaleTexture PlaneTexture,20,20

SetBuffer BackBuffer()

Return PlaneTexture

End Function

; ###################################################################################################

Function TerrainTexture(textureID=0)

If textureID=0 Then TerrainTexture=LoadTexture("media\terrain.png")
If textureID=1 Then TerrainTexture=LoadTexture("media\tcol1.png")
If textureID=2 Then TerrainTexture=LoadTexture("media\tcol2.png")
If textureID=3 Then TerrainTexture=LoadTexture("media\tcol3.png")
If textureID=4 Then TerrainTexture=LoadTexture("media\tcol4.png")

ScaleTexture TerrainTexture,0.08,0.08

Return TerrainTexture

End Function

; ###################################################################################################